
<?php
if( ! defined('BASEPATH')) exit('No direct script access allowed');
	//require_once(APPPATH.'/interfaces/IBase.php');	
	class Model_LoadedStockReport extends CI_Model 
	{
		public function __construct()
		{
			parent::__construct();	
		} 		
		public function select_all()
		{
			$this->db->select('loading_master.*,branch_master.branchName,FBranch.branchName As FromBranch');

			$this->db->join('branch_master As FBranch','FBranch.branchId =loading_master.fkFromBranchId');

			$this->db->join('branch_master','branch_master.branchId =loading_master.fkToBranchId');

			$this->db->from('loading_master');
			$this->db->where('loading_master.is_active',1);
			$this->db->where('fkFromBranchId',$_SESSION["fkBranchId"]);
	        $query = $this->db->get();
			return $query->result();
		}  	

		public function select($loadingId)
		{		

			$this->db->select('loading_master.*,loadingtrn.*,bilty_master.fksenderId,bilty_master.fkreceiverId,bilty_master.bookingDate,bilty_master.fkFromId,bilty_master.fkToId,bilty_master.fkbiltyTypeId,bilty_master.fkbrokerId,bilty_master.pakingSize,userregistration_master.userName,Sender.userName As SenderName,destination_master.destinationName,From.destinationName As FromName,branch_master.branchName,FBranch.branchName As FromBranch,vehical_master.vehicleName,rateasper_master.rateAsPerName,biltytype_master.biltyTypeName,broker_master.brokerName');

			$this->db->join('loadingtrn','loadingtrn.fkloadingId =loading_master.loadingId','left outer');
			
			$this->db->join('bilty_master','bilty_master.biltyId =loadingtrn.fkbiltyId','left outer');

			$this->db->join('branch_master As FBranch','FBranch.branchId =loading_master.fkFromBranchId');

			$this->db->join('branch_master','branch_master.branchId =loading_master.fkToBranchId');

			$this->db->join('vehical_master','vehical_master.vehicleId =loading_master.fkvehicleId');

			$this->db->join('rateasper_master','rateasper_master.rateAsPerId =loading_master.fkrateAsPerId');

			$this->db->join('userregistration_master As Sender','Sender.userId =bilty_master.fksenderId');
			
			$this->db->join('userregistration_master','userregistration_master.userId =bilty_master.fkreceiverId');
			
			$this->db->join('destination_master As From','From.destinationId =bilty_master.fkFromId');
			
			$this->db->join('destination_master','destination_master.destinationId =bilty_master.fkToId');

			$this->db->join('biltytype_master','biltytype_master.biltyTypeId =bilty_master.fkbiltyTypeId');

			$this->db->join('broker_master','broker_master.brokerId =bilty_master.fkbrokerId');

			$this->db->from('loading_master');
			$this->db->where('loading_master.loadingId',$loadingId);
			$this->db->where('fkFromBranchId',$_SESSION["fkBranchId"]);
			$this->db->where('loading_master.is_active',1);
			$this->db->where('loadingtrn.is_active',1);
	        $query = $this->db->get();

			return $query->result();
		}

		public function insert($tableName,$model)
		{
			return $this->db->insert($tableName,$model);
		}

		public function insertsub($model)
        {
             $this->db->insert('memo_master',$model);
        } 

		public function update($tableName,$model)
		{
			return  $this->db->where('loadingId',$model['loadingId'])
					         ->update($tableName,$model);

		}

		public function updateSub($model)
		{
			 return $sql=$this->db->where('biltyId',$model['biltyId'])
						  ->update('bilty_master',$model);
		}

		public function search($biltyId)
		{
			$sql=$this->db->get_where('bilty_master',['biltyId'=>$biltyId]);
			return $sql->result();
		} 	

		public function getMaxId()
		{
			return $this->db->select_max('loadingId')
					        ->get('loading_master')->result();
		}

		public function ProductList()
		{
			$this->db->select("productId,productName");
			$this->db->from('product_master');
			$this->db->where('is_active',1);
			$query = $this->db->get();
			return $query->result();
		}

		public function getDestination()
		{
			$this->db->select("destinationId,destinationName");
			$this->db->from('destination_master');
			$this->db->where('is_active',1);
			$query = $this->db->get();
			return $query->result();
		}

		public function getStockDetails($fromDate,$toDate,$fkFromId,$fkToId,$fkproductId)
		{

			if ($fromDate!='' && $toDate!='' && $fkFromId!='' && $fkToId!='' && $fkproductId!='') {
				// echo "All Values";

			$this->db->select('bilty_trn.fkproductId');

			$this->db->join('bilty_trn','bilty_trn.fkbiltyId =bilty_master.biltyId','left outer');

			$this->db->from('bilty_master');
			$this->db->group_by('bilty_trn.fkproductId');
			$this->db->where('bilty_master.bookingDate>=',$fromDate);
			$this->db->where('bilty_master.bookingDate<=',$toDate);
			$this->db->where('bilty_master.fkFromId',$fkFromId);
			$this->db->where('bilty_master.fkToId',$fkToId);
			$this->db->where('bilty_trn.fkproductId',$fkproductId);
			$this->db->where('bilty_master.loadingFlag',2);
			$this->db->where('bilty_master.is_active',1);
	        $query = $this->db->get();
			return $query->result_array();




			}
			elseif ($fromDate!='' && $toDate!='' && $fkFromId=='' && $fkToId=='' && $fkproductId=='') {
				// echo "From Date And To Date";

			$this->db->select('bilty_trn.fkproductId');

			$this->db->join('bilty_trn','bilty_trn.fkbiltyId =bilty_master.biltyId','left outer');

			$this->db->from('bilty_master');
			$this->db->group_by('bilty_trn.fkproductId');
			$this->db->where('bilty_master.bookingDate>=',$fromDate);
			$this->db->where('bilty_master.bookingDate<=',$toDate);
			$this->db->where('bilty_master.loadingFlag',2);
			$this->db->where('bilty_master.is_active',1);
	        $query = $this->db->get();
			return $query->result_array();

			}
			elseif ($fromDate!='' && $toDate!='' && $fkFromId!='' && $fkToId=='' && $fkproductId=='')  {
				// echo "Both Dates And From Destination";

			$this->db->select('bilty_trn.fkproductId');

			$this->db->join('bilty_trn','bilty_trn.fkbiltyId =bilty_master.biltyId','left outer');

			$this->db->from('bilty_master');
			$this->db->group_by('bilty_trn.fkproductId');
			$this->db->where('bilty_master.bookingDate>=',$fromDate);
			$this->db->where('bilty_master.bookingDate<=',$toDate);
			$this->db->where('bilty_master.fkFromId',$fkFromId);
			$this->db->where('bilty_master.loadingFlag',2);
			$this->db->where('bilty_master.is_active',1);
	        $query = $this->db->get();
			return $query->result_array();


			}
			elseif ($fromDate!='' && $toDate!='' && $fkFromId=='' && $fkToId!='' && $fkproductId=='')  {
				// echo "Both Dates And To Destination";

			$this->db->select('bilty_trn.fkproductId');

			$this->db->join('bilty_trn','bilty_trn.fkbiltyId =bilty_master.biltyId','left outer');

			$this->db->from('bilty_master');
			$this->db->group_by('bilty_trn.fkproductId');
			$this->db->where('bilty_master.bookingDate>=',$fromDate);
			$this->db->where('bilty_master.bookingDate<=',$toDate);
			$this->db->where('bilty_master.fkToId',$fkToId);
			$this->db->where('bilty_master.loadingFlag',2);
			$this->db->where('bilty_master.is_active',1);
	        $query = $this->db->get();
			return $query->result_array();

			}
			elseif ($fromDate!='' && $toDate!='' && $fkFromId!='' && $fkToId!='' && $fkproductId=='')  {
				// echo "Both Dates And Both Destination";
				
			$this->db->select('bilty_trn.fkproductId');

			$this->db->join('bilty_trn','bilty_trn.fkbiltyId =bilty_master.biltyId','left outer');

			$this->db->from('bilty_master');
			$this->db->group_by('bilty_trn.fkproductId');
			$this->db->where('bilty_master.bookingDate>=',$fromDate);
			$this->db->where('bilty_master.bookingDate<=',$toDate);
			$this->db->where('bilty_master.fkFromId',$fkFromId);
			$this->db->where('bilty_master.fkToId',$fkToId);
			$this->db->where('bilty_master.loadingFlag',2);
			$this->db->where('bilty_master.is_active',1);
	        $query = $this->db->get();
			return $query->result_array();

			}
			elseif ($fromDate!='' && $toDate!='' && $fkFromId=='' && $fkToId=='' && $fkproductId!='')
			 {
				// echo "Both Dates And Product";
				
			$this->db->select('bilty_trn.fkproductId');

			$this->db->join('bilty_trn','bilty_trn.fkbiltyId =bilty_master.biltyId','left outer');

			$this->db->from('bilty_master');
			$this->db->group_by('bilty_trn.fkproductId');
			$this->db->where('bilty_master.bookingDate>=',$fromDate);
			$this->db->where('bilty_master.bookingDate<=',$toDate);
			$this->db->where('bilty_trn.fkproductId',$fkproductId);
			$this->db->where('bilty_master.loadingFlag',2);
			$this->db->where('bilty_master.is_active',1);
	        $query = $this->db->get();
			return $query->result_array();
			

			}
			elseif ($fromDate!='' && $toDate!='' && $fkFromId!='' && $fkToId=='' && $fkproductId!='')  {
				// echo "Both Dates And From Destination And Product";
			
			$this->db->select('bilty_trn.fkproductId');

			$this->db->join('bilty_trn','bilty_trn.fkbiltyId =bilty_master.biltyId','left outer');

			$this->db->from('bilty_master');
			$this->db->group_by('bilty_trn.fkproductId');
			$this->db->where('bilty_master.bookingDate>=',$fromDate);
			$this->db->where('bilty_master.bookingDate<=',$toDate);
			$this->db->where('bilty_master.fkFromId',$fkFromId);
			$this->db->where('bilty_trn.fkproductId',$fkproductId);
			$this->db->where('bilty_master.loadingFlag',2);
			$this->db->where('bilty_master.is_active',1);
	        $query = $this->db->get();
			return $query->result_array();	

			
			}
		 elseif ($fromDate!='' && $toDate!='' && $fkFromId=='' && $fkToId!='' && $fkproductId!='')   {
				// echo "Both Dates And To Destination And Product";

			$this->db->select('bilty_trn.fkproductId');

			$this->db->join('bilty_trn','bilty_trn.fkbiltyId =bilty_master.biltyId','left outer');

			$this->db->from('bilty_master');
			$this->db->group_by('bilty_trn.fkproductId');
			$this->db->where('bilty_master.bookingDate>=',$fromDate);
			$this->db->where('bilty_master.bookingDate<=',$toDate);
			$this->db->where('bilty_master.fkToId',$fkToId);
			$this->db->where('bilty_trn.fkproductId',$fkproductId);
			$this->db->where('bilty_master.loadingFlag',2);
			$this->db->where('bilty_master.is_active',1);
	        $query = $this->db->get();
			return $query->result_array();	

			
			}
			

			
		}


		public function Terms(){

			$this->db->select("*");
			$this->db->from('organization_master');
			$this->db->where('is_active',1);
			$query = $this->db->get();
			return $query->result();

		}

		public function getproductDetails($fkproductId,$fromDate,$toDate,$fkFromId,$fkToId){

			if ($fromDate!='' && $toDate!='' && $fkFromId=='' && $fkToId=='') {
				# code...
				// echo "From Date And To Date";

			$this->db->select("bilty_trn.fkproductId,product_master.productName");
			$this->db->select_sum("bilty_trn.quantity");

			$this->db->join('bilty_trn','bilty_trn.fkbiltyId =bilty_master.biltyId','left outer');

			$this->db->join('product_master','product_master.productId =bilty_trn.fkproductId','left outer');

			$this->db->from('bilty_master');
			$this->db->where('bilty_master.bookingDate>=',$fromDate);
			$this->db->where('bilty_master.bookingDate<=',$toDate);
			$this->db->where_in('bilty_trn.fkproductId',$fkproductId);
			$this->db->where('bilty_master.loadingFlag',2);
			$this->db->where('bilty_trn.is_active',1);
			$query = $this->db->get();
			return $query->result();

			}
			elseif ($fromDate!='' && $toDate!='' && $fkFromId!='' && $fkToId=='') {
				// echo "Both Dates And From Destination";

				$this->db->select("bilty_trn.fkproductId,product_master.productName");
			$this->db->select_sum("bilty_trn.quantity");

			$this->db->join('bilty_trn','bilty_trn.fkbiltyId =bilty_master.biltyId','left outer');

			$this->db->join('product_master','product_master.productId =bilty_trn.fkproductId','left outer');

			$this->db->from('bilty_master');
			$this->db->where('bilty_master.bookingDate>=',$fromDate);
			$this->db->where('bilty_master.bookingDate<=',$toDate);
			$this->db->where('bilty_master.fkFromId',$fkFromId);
			$this->db->where_in('bilty_trn.fkproductId',$fkproductId);
			$this->db->where('bilty_master.loadingFlag',2);
			$this->db->where('bilty_trn.is_active',1);
			$query = $this->db->get();
			return $query->result();
			}
			elseif ($fromDate!='' && $toDate!='' && $fkFromId=='' && $fkToId!='') {
				// echo "Both Dates And To Destination";

			$this->db->select("bilty_trn.fkproductId,product_master.productName");
			
			$this->db->select_sum("bilty_trn.quantity");

			$this->db->join('bilty_trn','bilty_trn.fkbiltyId =bilty_master.biltyId','left outer');

			$this->db->join('product_master','product_master.productId =bilty_trn.fkproductId','left outer');

			$this->db->from('bilty_master');
			$this->db->where('bilty_master.bookingDate>=',$fromDate);
			$this->db->where('bilty_master.bookingDate<=',$toDate);
			$this->db->where('bilty_master.fkToId',$fkToId);
			$this->db->where_in('bilty_trn.fkproductId',$fkproductId);
			$this->db->where('bilty_master.loadingFlag',2);
			$this->db->where('bilty_trn.is_active',1);
			$query = $this->db->get();
			return $query->result();
			}
			elseif ($fromDate!='' && $toDate!='' && $fkFromId!='' && $fkToId!='') {
				// echo "Both Dates And Both Destination";

			$this->db->select("bilty_trn.fkproductId,product_master.productName");
			
			$this->db->select_sum("bilty_trn.quantity");

			$this->db->join('bilty_trn','bilty_trn.fkbiltyId =bilty_master.biltyId','left outer');

			$this->db->join('product_master','product_master.productId =bilty_trn.fkproductId','left outer');

			$this->db->from('bilty_master');
			$this->db->where('bilty_master.bookingDate>=',$fromDate);
			$this->db->where('bilty_master.bookingDate<=',$toDate);
			$this->db->where('bilty_master.fkFromId',$fkFromId);
			$this->db->where('bilty_master.fkToId',$fkToId);
			$this->db->where_in('bilty_trn.fkproductId',$fkproductId);
			$this->db->where('bilty_master.loadingFlag',2);
			$this->db->where('bilty_trn.is_active',1);
			$query = $this->db->get();
			return $query->result();
			}
			elseif ($fkproductId!=='' && $fromDate!='' && $toDate!='') {
			
			// echo "Both Dates And Product";
	
			$this->db->select("bilty_trn.fkproductId,product_master.productName");
			
			$this->db->select_sum("bilty_trn.quantity");

			$this->db->join('bilty_trn','bilty_trn.fkbiltyId =bilty_master.biltyId','left outer');

			$this->db->join('product_master','product_master.productId =bilty_trn.fkproductId','left outer');

			$this->db->from('bilty_master');
			$this->db->where('bilty_master.bookingDate>=',$fromDate);
			$this->db->where('bilty_master.bookingDate<=',$toDate);
			$this->db->where('bilty_trn.fkproductId',$fkproductId);
			$this->db->where_in('bilty_trn.fkproductId',$fkproductId);
			$this->db->where('bilty_master.loadingFlag',2);
			$this->db->where('bilty_trn.is_active',1);
			$query = $this->db->get();
			return $query->result();
			}
			elseif ($fkproductId!=='' && $fromDate!='' && $toDate!='' && $fkFromId!='') {
			
			// echo "Both Dates And From Destination";
	
			$this->db->select("bilty_trn.fkproductId,product_master.productName");
			
			$this->db->select_sum("bilty_trn.quantity");

			$this->db->join('bilty_trn','bilty_trn.fkbiltyId =bilty_master.biltyId','left outer');

			$this->db->join('product_master','product_master.productId =bilty_trn.fkproductId','left outer');

			$this->db->from('bilty_master');
			$this->db->where('bilty_master.bookingDate>=',$fromDate);
			$this->db->where('bilty_master.bookingDate<=',$toDate);
			$this->db->where('bilty_master.fkFromId',$fkFromId);
			$this->db->where('bilty_trn.fkproductId',$fkproductId);
			$this->db->where_in('bilty_trn.fkproductId',$fkproductId);
			$this->db->where('bilty_master.loadingFlag',2);
			$this->db->where('bilty_trn.is_active',1);
			$query = $this->db->get();
			return $query->result();
			}
			elseif ($fkproductId!=='' && $fromDate!='' && $toDate!='' && $fkToId!='') {
			
			// echo "Both Dates And To Destination";
	
			$this->db->select("bilty_trn.fkproductId,product_master.productName");
			
			$this->db->select_sum("bilty_trn.quantity");

			$this->db->join('bilty_trn','bilty_trn.fkbiltyId =bilty_master.biltyId','left outer');

			$this->db->join('product_master','product_master.productId =bilty_trn.fkproductId','left outer');

			$this->db->from('bilty_master');
			$this->db->where('bilty_master.bookingDate>=',$fromDate);
			$this->db->where('bilty_master.bookingDate<=',$toDate);
			$this->db->where('bilty_master.fkToId',$fkToId);
			$this->db->where('bilty_trn.fkproductId',$fkproductId);
			$this->db->where_in('bilty_trn.fkproductId',$fkproductId);
			$this->db->where('bilty_master.loadingFlag',2);
			$this->db->where('bilty_trn.is_active',1);
			$query = $this->db->get();
			return $query->result();
			}

			elseif ($fkproductId!=='' && $fromDate!='' && $toDate!='' && $fkFromId!='' && $fkToId!='') {
			
			// echo "All Values";
	
			$this->db->select("bilty_trn.fkproductId,product_master.productName");
			
			$this->db->select_sum("bilty_trn.quantity");

			$this->db->join('bilty_trn','bilty_trn.fkbiltyId =bilty_master.biltyId','left outer');

			$this->db->join('product_master','product_master.productId =bilty_trn.fkproductId','left outer');

			$this->db->from('bilty_master');
			$this->db->where('bilty_master.bookingDate>=',$fromDate);
			$this->db->where('bilty_master.bookingDate<=',$toDate);
			$this->db->where('bilty_master.fkFromId',$fkFromId);
			$this->db->where('bilty_master.fkToId',$fkToId);
			$this->db->where('bilty_trn.fkproductId',$fkproductId);
			$this->db->where_in('bilty_trn.fkproductId',$fkproductId);
			$this->db->where('bilty_master.loadingFlag',2);
			$this->db->where('bilty_trn.is_active',1);
			$query = $this->db->get();
			return $query->result();
			}

		}		

				
	} 
	
?>