<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	https://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|	$route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:	my-controller/index	-> my_controller/index
|		my-controller/my-method	-> my_controller/my_method
*/
$route['default_controller'] = 'Home';

$route['BookingCreate'] = 'Bilty/create';
$route['BookingIndex'] = 'Bilty/index';
$route['BookingEdit'.'/(:any)'] = 'Bilty/edit'.'/$1';
$route['BookingCancel'] = 'Bilty/Cancel';
$route['PrintBill'] = 'Bilty/PrintBill';

$route['BookingStatus'] = 'BookingStatus/create';

$route['BranchCreate'] = 'Branch/create';
$route['BranchIndex'] = 'Branch/index';
$route['BranchEdit'.'/(:any)'] = 'Branch/update'.'/$1';

$route['BrokerCreate'] = 'Broker/create';
$route['BrokerIndex'] = 'Broker/index';
$route['BrokerEdit'.'/(:any)'] = 'Broker/update'.'/$1';

$route['ChargesCreate'] = 'Charges/create';
$route['ChargesIndex'] = 'Charges/index';
$route['ChargesEdit'.'/(:any)'] = 'Charges/update'.'/$1';


$route['CompanyCreate'] = 'CompanyMaster/create';
$route['CompanyIndex'] = 'CompanyMaster/index';

$route['CityCreate'] = 'City/create';
$route['CityIndex'] = 'City/index';
$route['CityEdit'.'/(:any)'] = 'City/update'.'/$1';

$route['DestinationCreate'] = 'Destination/create';
$route['DestinationIndex'] = 'Destination/index';
$route['DestinationEdit'.'/(:any)'] = 'Destination/update'.'/$1';

$route['DispatchCreate'] = 'Dispatch/create';
$route['DispatchIndex'] = 'Dispatch/index';
$route['DispatchCancel'] = 'Dispatch/Cancel';

$route['DriverCreate'] = 'Driver/create';
$route['DriverIndex'] = 'Driver/index';
$route['DriverEdit'.'/(:any)'] = 'Driver/update'.'/$1';

$route['LoadingCreate'] = 'Loading/create';
$route['LoadingIndex'] = 'Loading/index';
$route['LoadingEdit'.'/(:any)'] = 'Loading/create'.'/$1';
$route['LoadingCancel'] = 'Loading/Cancel';

$route['RegistrationCreate'] = 'Loginregistration/create';
$route['RegistrationIndex'] = 'Loginregistration/index';
$route['RegistrationEdit'.'/(:any)'] = 'Loginregistration/update'.'/$1';

$route['MemoCreate'] = 'Memo/create';
$route['MemoIndex'] = 'Memo/index';
$route['MemoPrint'.'/(:any)'] = 'Memo/Print'.'/$1';
$route['MemoCancel'] = 'Memo/Cancel';

$route['PackagetypeCreate'] = 'Packagetype/create';
$route['PackagetypeIndex'] = 'Packagetype/index';
$route['PackagetypeEdit'.'/(:any)'] = 'Packagetype/update'.'/$1';

$route['PartyCreate'] = 'Party/create';
$route['PartyIndex'] = 'Party/index';
$route['PartyEdit'.'/(:any)'] = 'Party/update'.'/$1';

$route['ProductCreate'] = 'Product/create';
$route['ProductIndex'] = 'Product/index';
$route['ProductEdit'.'/(:any)'] = 'Product/update'.'/$1';

$route['ProductChargesCreate'] = 'ProductCharges/create';
$route['ProductChargesIndex'] = 'ProductCharges/index';
$route['ProductChargesEdit'.'/(:any)'] = 'ProductCharges/create'.'/$1';

$route['Receive'] = 'Receive/create';

$route['StateCreate'] = 'State/create';
$route['StateIndex'] = 'State/index';
$route['StateEdit'.'/(:any)'] = 'State/update'.'/$1';

$route['TrackVehicleIndex'] = 'Trackvehicle/index';
$route['Start'] = 'StartTracking/create';

$route['VehicleCreate'] = 'Vehicelinfo/create';
$route['VehicleIndex'] = 'Vehicelinfo/index';
$route['VehicleEdit'.'/(:any)'] = 'Vehicelinfo/update'.'/$1';

$route['BiltyReport'] = 'BiltyReport/create';
$route['LoadingReport'] = 'LoadingReport/create';
$route['MemoReport'] = 'MemoReport/create';

$route['UnloadedStockReport'] = 'UnloadedStockReport/create';
$route['LoadedStockReport'] = 'LoadedStockReport/create';

$route['404_override'] = '';
$route['translate_uri_dashes'] = FALSE;
